<?php

namespace StructType;

use \WsdlToPhp\PackageBase\AbstractStructBase;

/**
 * This class stands for JP_HotelContractType StructType
 * @subpackage Structs
 */
class JP_HotelContractType extends JP_Contract
{
    /**
     * The Name
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Name;
    /**
     * The Description
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var string
     */
    public $Description;
    /**
     * The Characteristics
     * Meta information extracted from the WSDL
     * - maxOccurs: 1
     * - minOccurs: 0
     * @var \ArrayType\ArrayOfJP_ContractCharacteristics
     */
    public $Characteristics;
    /**
     * Constructor method for JP_HotelContractType
     * @uses JP_HotelContractType::setName()
     * @uses JP_HotelContractType::setDescription()
     * @uses JP_HotelContractType::setCharacteristics()
     * @param string $name
     * @param string $description
     * @param \ArrayType\ArrayOfJP_ContractCharacteristics $characteristics
     */
    public function __construct($name = null, $description = null, \ArrayType\ArrayOfJP_ContractCharacteristics $characteristics = null)
    {
        $this
            ->setName($name)
            ->setDescription($description)
            ->setCharacteristics($characteristics);
    }
    /**
     * Get Name value
     * @return string|null
     */
    public function getName()
    {
        return $this->Name;
    }
    /**
     * Set Name value
     * @param string $name
     * @return \StructType\JP_HotelContractType
     */
    public function setName($name = null)
    {
        // validation for constraint: string
        if (!is_null($name) && !is_string($name)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($name, true), gettype($name)), __LINE__);
        }
        $this->Name = $name;
        return $this;
    }
    /**
     * Get Description value
     * @return string|null
     */
    public function getDescription()
    {
        return $this->Description;
    }
    /**
     * Set Description value
     * @param string $description
     * @return \StructType\JP_HotelContractType
     */
    public function setDescription($description = null)
    {
        // validation for constraint: string
        if (!is_null($description) && !is_string($description)) {
            throw new \InvalidArgumentException(sprintf('Invalid value %s, please provide a string, %s given', var_export($description, true), gettype($description)), __LINE__);
        }
        $this->Description = $description;
        return $this;
    }
    /**
     * Get Characteristics value
     * @return \ArrayType\ArrayOfJP_ContractCharacteristics|null
     */
    public function getCharacteristics()
    {
        return $this->Characteristics;
    }
    /**
     * Set Characteristics value
     * @param \ArrayType\ArrayOfJP_ContractCharacteristics $characteristics
     * @return \StructType\JP_HotelContractType
     */
    public function setCharacteristics(\ArrayType\ArrayOfJP_ContractCharacteristics $characteristics = null)
    {
        $this->Characteristics = $characteristics;
        return $this;
    }
}
